
use<threads.scad>

/* [Parte a mostrar] */
// Elemento que desea mostrar en pantalla
Mostrar = "Alta";    //[Cajon:Caja competa para hacerse una idea de cómo quedará, Alta:Carcasa Superior, Baja:Carcasa inferior, Contrapeso:Cajeado inferior para su uso como contrapeso, Carcasa:Carcasa para que los pulsadores queden hundidos, Separador:Separador para la carcasa, Tapa:Tapa del joystick, Barra:Palanca del joystick, Agarre:Pomo del joystick, Tope:Tope del muelle, Casq:Casquillo inferior del joystick, Patas:Pata para la carcasa, Pres:Presilla para la palanca del joystick, Tope_Arduino:Tope para evitar que se desplace el Arduino]


/* [Parámetros de la caja] */

// Largo de la caja
Largo = 175;    //[80:1:250]

// Ancho de la caja
Ancho = 120;    //[80:1:250]

// Alto de la caja
Alto = 70;       //[50:1:100]

// Alto de la caja para el contrapeso
Alto_Peso = 15;       //[15:1:50]

// Ángulo de inclinación en la parte superior
Angulo = 8;

// Grosor de las paredes de la caja (nunca puede ser igual o superior a la mitad del valor de "Curvado")
Grosor =2.5;     //[2:0.5:3]

// Diámetro de curvatura de las aristas verticales
Curvado = 10;     //[7:1:14]

// ¿Desea pulsadores o conectores para pulsadores externos?
Pulsacon = "Ambos";    //[Pulsadores:Pulsadores, Conectores:Conectores, Ambos:Ambos]



/* [Parámetros de la carcasa] */

// ¿Desea una carcasa para que no sobresalgan los pulsadores?
Protector = "NO";    //[SI:Sí, NO:No]

// Grosor de la carcasa
Grosor_Carcasa = 6;    //[4:0.5:8]

//Distancia entre la carcasa y el joystick
Distancia = 5;      //[3:0.5:10]


/* [Parámetros del joystick] */

// Longitud de la palanca (sin contar el pomo)
Largo_Palanca = 25;

// Diámetro del pomo de agarre
Dia_Pomo = 40;      //[25:1:60]

// Diámetro interior del muelle
DIM = 21.5;     //[20:0.5:25]

// Longitud del muelle cuando está totalmente comprimido
LMC = 11;

// Longitud del muelle cuando está en reposo
LMR = 45;

// Desplazamiento del joystick en el eje X con respecto al centro
DX = 0;

// Desplazamiento del joystick en el eje Y con respecto al centro
DY = 0;


/* [Parámetros de los pulsadores] */

// Diámetro del pulsador 1
Diametro_P1 = 28;

// Diámetro del pulsador 2
Diametro_P2 = 24;

// Diámetro del pulsador 3
Diametro_P3 = 28;

// Diámetro del pulsador 4
Diametro_P4 = 28;

// Distancia en el eje X (ancho) desde el centro de la caja del pulsador 1
DXP1 = -32;

// Distancia en el eje Y (largo) desde el centro de la caja del pulsador 1
DYP1 = 60;

// Distancia en el eje X (ancho) desde el centro de la caja del pulsador 2
DXP2 = 32;

// Distancia en el eje Y (largo) desde el centro de la caja del pulsador 2
DYP2 = 60;

// Distancia en el eje X (ancho) desde el centro de la caja del pulsador 3
DXP3 = -32;

// Distancia en el eje Y (largo) desde el centro de la caja del pulsador 3
DYP3 = -60;

// Distancia en el eje X (ancho) desde el centro de la caja del pulsador 4
DXP4 = 32;

// Distancia en el eje Y (largo) desde el centro de la caja del pulsador 4
DYP4 = -60;


/* [Parámetros de los conectores] */

// Diámetro del conector
Diametro_C = 6.1;

// Distancia en el eje X (ancho) desde el centro de la caja del conector 1
DXC1 = 20;

// Distancia en el eje Z (alto) desde el borde superior de la caja del conector 1
DZC1 = 30;

// Distancia en el eje X (ancho) desde el centro de la caja del conector 2
DXC2 = 40;

// Distancia en el eje Z (alto) desde el borde superior de la caja del conector 2
DZC2 = 30;

// Distancia en el eje X (ancho) desde el centro de la caja del conector 3
DXC3 = -20;

// Distancia en el eje Z (alto) desde el borde superior de la caja del conector 3
DZC3 = 30;

// Distancia en el eje X (ancho) desde el centro de la caja del conector 4
DXC4 = -40;

// Distancia en el eje Z (alto) desde el borde superior de la caja del conector 4
DZC4 = 30;

// ¿En qué lado de la caja desea que se encuentre el conector del Arduino
CArduino = "Detras";    //[Izquierda:Izquierda, Derecha:Derecha, Detras:Detrás]

// Distancia en el eje Z (alto) desde el borde superior de la caja al conector del Arduino
DZA = 35;

// Distancia en el eje Y (largo) desde el centro de la caja al conector del Arduino (solo en el caso de vaya en un lateral)
DYA = 0;

// Distancia en el eje X (ancho) desde el centro de la caja al conector del Arduino (solo en el caso de vaya detrás)
DXA = 0;




/* [Hidden] */
Redondeo = 3.99;

Ang = -Angulo;

Alto_M = (LMC+LMR)/2+Grosor;

Levantamiento = (Alto-Largo*(tan(Angulo)))/2-Alto/2-0.13;

Z=-(tan(Angulo))*DY;

Y=(tan(Angulo));

KKK = Largo*(tan(Angulo));





/////////////////////  Generación del alojamiento de la palanca /////////////////////

module Atornillado() {
difference() {
    cylinder(d=9,h=Alto_M,$fn=120,center=true);
        translate([0,0,-1]) cylinder(d=3.5,h=Alto_M,$fn=120,center=true);
}
translate([2.25,3.5,0]) cube([4.5,2,Alto_M],center=true);
translate([3.5,2.25,0]) cube([2,4.5,Alto_M],center=true);
}


module Tornillo_Tapa() {
    translate([0,0,3.08]) cylinder(d=4.2,h=10,$fn=120);
    translate([0,0,0.99]) cylinder(d1=7.8,d2=4.2,h=2.1,$fn=120);
    translate([0,0,-0.2]) cylinder(d=7.8,h=1.2,$fn=120);
}

module Tope_F_C() {
    translate([-4.06,8.66,0]) cube([22.5,1.4,1],center=true);
    translate([-14.61,2,0]) cube([1.4,13,1],center=true);
}


module F_Carrera() {
difference() {
    translate([0,0,0]) cube([27.8,15.9,10.3],center=true);
        translate([-11.1,-5.15,0]) cylinder(d=3.4,h=15,$fn=120,center=true);
        translate([11.1,5.15,0]) cylinder(d=3.2,h=15,$fn=120,center=true);
}
translate([-11,9,0]) rotate([0,0,-5]) cube([27.8,0.6,10.3],center=true);
}

module Alojamiento_Joystick() {
// Caja del joystick
difference() {
    translate([0,0,0]) cube([64,64,Alto_M],center=true);
        translate([0,0,-Grosor]) cube([58,58,Alto_M],center=true);
        translate([0,0,-Alto_M+4]) cube([60,60,Alto_M],center=true);
*translate([0,0,Alto_M/2-1.59-Grosor/2]) cylinder(d1=20.5,d2=22.5,h=3.2+Grosor,center=true,$fn=120);
}

// Taladros para los tornillos de la caja
translate([25.5,25.5,0]) rotate([0,0,0]) Atornillado();
translate([-25.5,25.5,0]) rotate([0,0,90]) Atornillado();
translate([25.5,-25.5,0]) rotate([0,0,-90]) Atornillado();
translate([-25.5,-25.5,0]) rotate([0,0,180]) Atornillado();

// Refuerzo del hueco central para la palanca
difference() {
translate([0,0,Alto_M/2-(3+Grosor)/2]) cylinder(d=28,h=3+Grosor,center=true,$fn=120);
translate([0,0,Alto_M/2-1.59-Grosor/2]) cylinder(d1=20.5,d2=22.5,h=3.2+Grosor,center=true,$fn=120);
}
}


module Tapa_Joystick() {
difference() {
    union() {
        translate([0,0,-16.5]) cube([64,64,5],center=true);
        translate([0,29,-12.25]) cube([44,1,3.5],center=true);
        translate([0,-29,-12.25]) cube([44,1,3.5],center=true);
        translate([29,0,-12.25]) cube([1,44,3.5],center=true);
        translate([-29,0,-12.25]) cube([1,44,3.5],center=true);
        translate([0,0,-14+(Alto_M/2-Grosor/2)/2]) cylinder(d=DIM-0.2,h=Alto_M/2-Grosor/2,$fn=120,center=true);
        translate([4.39,27.1,-13]) cylinder(d=4.8,h=5,$fn=120,center=true);
        translate([27.1,-4.39,-13]) cylinder(d=4.8,h=5,$fn=120,center=true);
        translate([-4.39,-27.1,-13]) cylinder(d=4.8,h=5,$fn=120,center=true);
        translate([-27.1,4.39,-13]) cylinder(d=4.8,h=5,$fn=120,center=true);
        translate([25.61,14.9,-22.5]) cylinder(d=3,h=7,$fn=120,center=true);
        translate([14.9,-25.61,-22.5]) cylinder(d=3,h=7,$fn=120,center=true);
        translate([-25.61,-14.9,-22.5]) cylinder(d=3,h=7,$fn=120,center=true);
        translate([-14.9,25.61,-22.5]) cylinder(d=3,h=7,$fn=120,center=true);
        translate([15,21,-19.5]) rotate([0,0,-5]) Tope_F_C();
        translate([-21,15,-19.5]) rotate([0,0,85]) Tope_F_C();
        translate([21,-15,-19.5]) rotate([0,0,-95]) Tope_F_C();
        translate([-15,-21,-19.5]) rotate([0,0,-185]) Tope_F_C();
    }
        translate([25.5,25.5,-18.81]) Tornillo_Tapa();
        translate([-25.5,25.5,-18.81]) Tornillo_Tapa();
        translate([25.5,-25.5,-18.81]) Tornillo_Tapa();
        translate([-25.5,-25.5,-18.81]) Tornillo_Tapa();
        translate([0,0,-10]) cylinder(d=12.5,h=50,$fn=120,center=true);
        translate([0,0,-17+(Alto_M/2-Grosor/2)/2]) cylinder(d=18.8,h=Alto_M/2-Grosor/2,$fn=120,center=true);
        translate([0,0,-18.75]) cylinder(d=26.5,h=5,$fn=120,center=true);
        translate([4.39,27.1,-15]) cylinder(d=2.6,h=20,$fn=120,center=true);
        translate([27.1,-4.39,-15]) cylinder(d=2.6,h=20,$fn=120,center=true);
        translate([-4.39,-27.1,-15]) cylinder(d=2.6,h=20,$fn=120,center=true);
        translate([-27.1,4.39,-15]) cylinder(d=2.6,h=20,$fn=120,center=true);
    
}

}



/////////////////////  Generación de la palanca, pomo y casquillos /////////////////////

module Tope_Muelle() {
difference() {
    union() {
        translate([0,0,-3.5]) cylinder(d=DIM-0.2,h=5,$fn=120,center=true);
        translate([0,0,0]) cylinder(d=28,h=2,$fn=120,center=true);
        translate([0,0,1]) cylinder(d=15.5,h=Alto_M/2-5,$fn=120);
    }
        translate([0,0,0]) cylinder(d=10.4,h=30,$fn=120,center=true);
}
}


module Casquillo() {
difference() {
    union() {
        translate([0,0,0]) cylinder(d1=22,d2=20,h=8,$fn=120);
        translate([0,0,8]) cylinder(d=14.5,h=5,$fn=120);
        translate([0,0,13]) cylinder(d1=14.5,d2=16.5,h=8.5+Grosor,$fn=120);
    }
            translate([0,0,-5]) cylinder(d=10.4,h=50,$fn=120);
}
}


module Palanca() {
translate([0,0,0]) cylinder(d=10,h=5,$fn=120);
translate([0,0,5]) cylinder(d=7.3,h=4.3,$fn=120);
translate([0,0,9.3]) cylinder(d=10,h=Alto_M+17,$fn=120);
translate([0,0,Alto_M+17+9.3]) cylinder(d=14,h=Largo_Palanca,$fn=120);
translate([0,0,Alto_M+17+9.3+Largo_Palanca]) metric_thread(diameter=14, pitch=2, length=15, internal=false, n_starts=1);
}


module Presilla() {
difference() {
    cylinder(d=13,h=4,$fn=120,center=true);
        cylinder(d=7.8,h=5,$fn=120,center=true);
        translate([0,5,0]) cube([6,10,5],center=true);
}
}


module Pomo() {
difference() {
    sphere(d=Dia_Pomo,$fn=200);
        translate([0,0,-Dia_Pomo*0.8]) cube(Dia_Pomo,center=true);
        translate([0,0,-Dia_Pomo/2-Dia_Pomo*0.8+15]) metric_thread(diameter=14.4, pitch=2, length=Dia_Pomo, internal=true, n_starts=1);
}
}




/////////////////////  Generación de la caja /////////////////////

module Tornillo_Caja() {
difference() {
    union() {
        cylinder(d=8,h=Alto,$fn=120,center=true);
        translate([3,-1,0]) cube([6,6,Alto],center=true);
        translate([-1,3,0]) cube([6,6,Alto],center=true);
        translate([3,3,0]) cylinder(d=Redondeo-0.5,h=Alto,$fn=120,center=true);
    }
        translate([0,0,-1]) cylinder(d=2.8,h=Alto+4,$fn=120,center=true);
}
}


module Tornillo_Bajo() {
    union() {
        cylinder(d=8,h=Alto,$fn=120,center=true);
        translate([3,-1,0]) cube([6,6,Alto],center=true);
        translate([-1,3,0]) cube([6,6,Alto],center=true);
        translate([3,3,0]) cylinder(d=Redondeo-0.5,h=Alto,$fn=120,center=true);
    }
}


module Tornillo() {
    cylinder(h= 20,d=3.3,$fn=80);
    translate([0,0,19.999]) cylinder(h=2.5,d1=3.5,d2=6.4,$fn=80);
}


module Jack() {
translate([0,0,0]) cube([8,2,8],center=true);
translate([0,5,0]) rotate([90,0,0]) cylinder(d=Diametro_C,h=10,$fn=120,center=true);
}

module Base_Arduino() {
difference() {
    union() {
        translate([0,0,0]) cube([33.2,10,66],center=true);
        translate([3.5,-10.6,-1]) cube([40.2,3,68],center=true);
        translate([3.5,10.6,-1]) cube([40.2,3,68],center=true);
    }
            translate([1,0,4]) cube([15,35,65],center=true);
            translate([17.6,0,-35]) cube([2,25,10],center=true);
            translate([17.6,-11.2,-23.9]) cube([2.4,2,3.2],center=true);
            translate([17.6,11.2,-23.9]) cube([2.4,2,3.2],center=true);
}
}

module Tuerca() {
difference() {
	translate([0,0,0]) rotate([0,0,0]) cylinder(d=10,h=4,$fn=120,center=true);
		translate([0,0,0]) rotate([0,0,0]) cylinder(d=6.2,h=6,$fn=6,center=true);
}
}


// Cierre del Arduino
module Cierre() {
difference() {
    translate([0,13.8,4.9]) cube([27,1.8,11.2],center=true);
        translate([-10.6,29.4,0]) cube([3,39.2,8],center=true);
        translate([10.6,27.4,0]) cube([3,39.2,8],center=true);
}
difference() {
    translate([12.3,13.8,-2.45]) cube([2.4,1.8,3.5],center=true);
        translate([10.97,13.8,-3.2]) rotate([0,-25,0]) cube([2.4,4,6],center=true);
}
mirror([1,0,0]) difference() {
    translate([12.3,13.8,-2.45]) cube([2.4,1.8,3.5],center=true);
        translate([10.97,13.8,-3.2]) rotate([0,-25,0]) cube([2.4,4,6],center=true);
}
translate([0,15.7,9.5]) cube([11,2,2],center=true);
}

module Pata() {
translate([0,0,0]) cylinder(d=6,h=7,$fn=120);
translate([0,0,0]) cylinder(d=8,h=3,$fn=120);
}

module Caja() {
  difference() {
    minkowski() {
      rotate([0,0,180])difference() {
        hull() {
          translate([Ancho/2-Curvado/2-Redondeo/2,Largo/2-Curvado/2-Redondeo/2,0]) cylinder(d=Curvado,h=Alto-Redondeo,$fn=80,center=true);
          translate([-Ancho/2+Curvado/2+Redondeo/2,Largo/2-Curvado/2-Redondeo/2,0]) cylinder(d=Curvado,h=Alto-Redondeo,$fn=80,center=true);
          translate([Ancho/2-Curvado/2-Redondeo/2,-Largo/2+Curvado/2+Redondeo/2,0]) cylinder(d=Curvado,h=Alto-Redondeo,$fn=80,center=true);
          translate([-Ancho/2+Curvado/2+Redondeo/2,-Largo/2+Curvado/2+Redondeo/2,0]) cylinder(d=Curvado,h=Alto-Redondeo,$fn=80,center=true);
        }
          translate([-(Ancho*1.5)/2,-Largo/2,Alto/2-Redondeo/2]) rotate([Ang,0,0]) cube([Ancho*1.5, Largo*1.5, Alto]);
      }
      sphere(d=Redondeo,$fn=40);
    }
// Resta interior
      minkowski() {
        rotate([0,0,180])difference() {
          hull() {
            translate([Ancho/2-Curvado/2-Redondeo/2,Largo/2-Curvado/2-Redondeo/2,0]) cylinder(d=Curvado-Grosor*2,h=Alto-Redondeo-Grosor*2,$fn=80,center=true);
            translate([-Ancho/2+Curvado/2+Redondeo/2,Largo/2-Curvado/2-Redondeo/2,0]) cylinder(d=Curvado-Grosor*2,h=Alto-Redondeo-Grosor*2,$fn=80,center=true);
            translate([Ancho/2-Curvado/2-Redondeo/2,-Largo/2+Curvado/2+Redondeo/2,0]) cylinder(d=Curvado-Grosor*2,h=Alto-Redondeo-Grosor*2,$fn=80,center=true);
            translate([-Ancho/2+Curvado/2+Redondeo/2,-Largo/2+Curvado/2+Redondeo/2,0]) cylinder(d=Curvado-Grosor*2,h=Alto-Redondeo-Grosor*2,$fn=80,center=true);
    }
            translate([-(Ancho*1.5)/2,-Largo/2,Alto/2-Redondeo/2-Grosor]) rotate([Ang,0,0]) cube([Ancho*1.5, Largo*1.5, Alto]);
        }
        sphere(d=Redondeo,$fn=40);
      }
  }
}


module Superior1() {
difference() {
    Caja();
      //Corte inferior
      translate([0,0,-Alto*0.7]) cube([Ancho*1.5, Largo*1.5, Alto],center=true);
  }
// Alojamiento para los tornillos del cierre de la caja
difference() {
    union() {
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,0]) rotate([0,0,0]) Tornillo_Caja();
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,0]) rotate([0,0,90]) Tornillo_Caja();
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,0]) rotate([0,0,-90]) Tornillo_Caja();
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,0]) rotate([0,0,180]) Tornillo_Caja();
    }
            translate([0,0,-Alto*0.7+2]) rotate([0,0,0]) cube([Ancho+50,Largo+50,Alto],center=true);
            translate([0,0,Alto+Levantamiento-0.8]) rotate([0,0,0]) rotate([Angulo,0,0]) cube([Ancho+50,Largo+50,Alto],center=true);
}
}


module Superior2() {
    difference() {
        union() {
            rotate([Ang,0,0]) translate([0,0,-Alto/2+KKK/2]) Superior1();
            translate([DX,DY,-Alto_M/2]) Alojamiento_Joystick();
        }
// Taladro para la palanca del joystick
            translate([DX,DY,-Grosor]) cylinder(d1=20.5,d2=22.5,h=3.2+Grosor,center=true,$fn=200);
// Taladros para los pulsadores
        if (Pulsacon=="Pulsadores" || Pulsacon=="Ambos") {
            translate([DXP1, DYP1,-Grosor/2]) cylinder(d=Diametro_P1,h=10,$fn=160,center=true);
            translate([DXP2, DYP2,-Grosor/2]) cylinder(d=Diametro_P2,h=10,$fn=160,center=true);
            translate([DXP3, DYP3,-Grosor/2]) cylinder(d=Diametro_P3,h=10,$fn=160,center=true);
            translate([DXP4, DYP4,-Grosor/2]) cylinder(d=Diametro_P4,h=10,$fn=160,center=true);
        }
// Taladros para los tornillos de la carcasa
      if (Protector=="SI") {
			translate([Ancho/2-Curvado/2-Redondeo/2,Largo/2-Curvado/2-Redondeo/2-8,Grosor_Carcasa/2]) cylinder(d=3.3,h=20,$fn=120,center=true);
      translate([-Ancho/2+Curvado/2+Redondeo/2,Largo/2-Curvado/2-Redondeo/2-8,Grosor_Carcasa/2]) cylinder(d=3.3,h=20,$fn=120,center=true);
      translate([Ancho/2-Curvado/2-Redondeo/2,-Largo/2+Curvado/2+Redondeo/2+8,Grosor_Carcasa/2]) cylinder(d=3.3,h=20,$fn=120,center=true);
      translate([-Ancho/2+Curvado/2+Redondeo/2,-Largo/2+Curvado/2+Redondeo/2+8,Grosor_Carcasa/2]) cylinder(d=3.3,h=20,$fn=120,center=true);
			}
}
if (Protector=="SI") {
	translate([Ancho/2-Curvado/2-Redondeo/2,Largo/2-Curvado/2-Redondeo/2-8,-Grosor_Carcasa/2]) Tuerca();
	translate([-Ancho/2+Curvado/2+Redondeo/2,Largo/2-Curvado/2-Redondeo/2-8,-Grosor_Carcasa/2]) Tuerca();
	translate([Ancho/2-Curvado/2-Redondeo/2,-Largo/2+Curvado/2+Redondeo/2+8,-Grosor_Carcasa/2]) Tuerca();
	translate([-Ancho/2+Curvado/2+Redondeo/2,-Largo/2+Curvado/2+Redondeo/2+8,-Grosor_Carcasa/2]) Tuerca();
}
}


module Superior() {
difference() {
rotate([Angulo,0,0]) Superior2();
// Taladros para los conectores
        if (Pulsacon=="Conectores" || Pulsacon=="Ambos") {
            translate([DXC1, Largo/2-3,Grosor-DZC1]) Jack();
            translate([DXC2, Largo/2-3,Grosor-DZC2]) Jack();
            translate([DXC3, Largo/2-3,Grosor-DZC3]) Jack();
            translate([DXC4, Largo/2-3,Grosor-DZC4]) Jack();
        } 
            if (CArduino=="Izquierda") {
            translate([-Ancho/2,DYA,-Levantamiento-DZA]) cube([10,8.5,3.3],center=true);
            }
            if (CArduino=="Derecha") {
            translate([Ancho/2,DYA,-Levantamiento-DZA]) cube([10,8.5,3.3],center=true);
            }
            if (CArduino=="Detras") {
            translate([DXA,Largo/2,-Levantamiento-DZA]) rotate([0,0,-90]) cube([10,8.5,3.3],center=true);
            }

}
if (CArduino=="Izquierda") {
difference() {
translate([-Ancho/2+33.2/2+Grosor, DYA,35.5-Levantamiento-DZA]) Base_Arduino();
translate([0,0,Alto*2+Levantamiento-0.8-Alto+KKK/2]) rotate([Angulo,0,0]) cube([Ancho+50,Largo+50,Alto*2],center=true);
}
}

if (CArduino=="Derecha") {
difference() {
translate([Ancho/2-33.2/2-Grosor, DYA,35.5-Levantamiento-DZA]) rotate([0,0,180]) Base_Arduino();
translate([0,0,Alto*2+Levantamiento-0.8-Alto+KKK/2]) rotate([Angulo,0,0]) cube([Ancho+50,Largo+50,Alto*2],center=true);
}
}

if (CArduino=="Detras") {
difference() {
translate([DXA, Largo/2-33.2/2-Grosor,35.5-Levantamiento-DZA]) rotate([0,0,-90]) Base_Arduino();
translate([0,0,Alto*2+Levantamiento-0.8-Alto+KKK/2]) rotate([Angulo,0,0]) cube([Ancho+50,Largo+50,Alto*2],center=true);
}
}
}


module Inferior1() {
  difference() {
    Caja();
// Corte superior
        translate([0,0,Alto*0.3]) cube([Ancho*1.5, Largo*1.5, Alto],center=true);
  }
}


module Inferior() {
difference() {
    union() {
        Inferior1();
// Encajes con la parte superior
        difference() {
            union() {
                translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,0]) rotate([0,0,0]) Tornillo_Bajo();
                translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,0]) rotate([0,0,90]) Tornillo_Bajo();
                translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,0]) rotate([0,0,-90]) Tornillo_Bajo();
                translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,0]) rotate([0,0,180]) Tornillo_Bajo();
            }
            translate([0,0,-Alto+Redondeo/2]) cube([Ancho*1.5, Largo*1.5, Alto],center=true);
            translate([0,0,Alto*0.3+1.9]) cube([Ancho*1.5, Largo*1.5, Alto],center=true);
            Superior1();
        }
    }
// Huecos para los tornillos
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Alto*0.3]) cylinder(d=3.3,h=Alto,$fn=120,center=true);
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,0]) cylinder(d=3.3,h=Alto,$fn=120,center=true);
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,0]) cylinder(d=3.3,h=Alto,$fn=120,center=true);
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,0]) cylinder(d=3.3,h=Alto,$fn=120,center=true);
// Huecos para la cabeza de los tornillos
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Alto+Alto*0.3-5]) cylinder(d=6,h=Alto,$fn=120,center=true);
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Alto+Alto*0.3-5]) cylinder(d=6,h=Alto,$fn=120,center=true);
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Alto+Alto*0.3-5]) cylinder(d=6,h=Alto,$fn=120,center=true);
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Alto+Alto*0.3-5]) cylinder(d=6,h=Alto,$fn=120,center=true);
// Huecos para las lágrimas
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Alto+1]) cylinder(d=8,h=Alto,$fn=120,center=true);
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Alto+1]) cylinder(d=8,h=Alto,$fn=120,center=true);
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Alto+1]) cylinder(d=8,h=Alto,$fn=120,center=true);
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Alto+1]) cylinder(d=8,h=Alto,$fn=120,center=true);
        
//Tornillos de placa de Fijación
        translate([-30,15,-Alto/2-19.9]) Tornillo();
        translate([30,15,-Alto/2-19.9]) Tornillo();
        translate([0,-15,-Alto/2-19.9]) Tornillo();
}
}


module Encaje() {
    difference() {
        cylinder(d=7.7,h=0.8,$fn=120,center=true);
            cylinder(d=3.3,h=5,$fn=120,center=true);
    }
}

module Peso() {
difference() {
    union() {
        Caja();
// Refuerzos de las esquinas
        difference() {
            union() {
                translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,0]) rotate([0,0,0]) Tornillo_Bajo();
                translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,0]) rotate([0,0,90]) Tornillo_Bajo();
                translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,0]) rotate([0,0,-90]) Tornillo_Bajo();
                translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,0]) rotate([0,0,180]) Tornillo_Bajo();
            }
            translate([0,0,-Alto+Redondeo/2]) cube([Ancho*1.5, Largo*1.5, Alto],center=true);
            *translate([0,0,Alto*0.3+1.9]) cube([Ancho*1.5, Largo*1.5, Alto],center=true);
        }
    }
    translate([0,0,-Alto+Alto_Peso/2+(Alto-Alto_Peso)+Alto_Peso]) cube([Ancho+10, Largo+10,Alto-Alto_Peso+0.01],center=true);
// Huecos para los tornillos
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,0]) cylinder(d=3.3,h=Alto*2,$fn=120,center=true);
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,0]) cylinder(d=3.3,h=Alto*2,$fn=120,center=true);
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,0]) cylinder(d=3.3,h=Alto*2,$fn=120,center=true);
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,0]) cylinder(d=3.3,h=Alto*2,$fn=120,center=true);
// Huecos para la cabeza de los tornillos
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Alto+Alto*0.3-10]) cylinder(d=6,h=Alto,$fn=120,center=true);
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Alto+Alto*0.3-10]) cylinder(d=6,h=Alto,$fn=120,center=true);
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Alto+Alto*0.3-10]) cylinder(d=6,h=Alto,$fn=120,center=true);
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Alto+Alto*0.3-10]) cylinder(d=6,h=Alto,$fn=120,center=true);
// Huecos para las lágrimas
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Alto+1]) cylinder(d=8,h=Alto,$fn=120,center=true);
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Alto+1]) cylinder(d=8,h=Alto,$fn=120,center=true);
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Alto+1]) cylinder(d=8,h=Alto,$fn=120,center=true);
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Alto+1]) cylinder(d=8,h=Alto,$fn=120,center=true);
}
// Encajes para la parte superior
translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Alto/2+Alto_Peso+0.8/2]) Encaje();
translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,Largo/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Alto/2+Alto_Peso+0.8/2]) Encaje();
        translate([Ancho/2-Curvado/2-Redondeo/2+(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Alto/2+Alto_Peso+0.8/2]) Encaje();
        translate([-Ancho/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Largo/2+Curvado/2+Redondeo/2-(Curvado-10)/2,-Alto/2+Alto_Peso+0.8/2]) Encaje();
}

module Carcasa() {
module Tornillo_M3() {
    translate([0,0,-12.58]) cylinder(d=3.3,h=10,$fn=120);
    translate([0,0,-2.59]) cylinder(d1=3.3,d2=6,h=2.1,$fn=120);
    translate([0,0,-0.5]) cylinder(d=6,h=0.6,$fn=120);
}


module Agujero(D_I=Diametro_P1,D_Grosor=Grosor_Carcasa,Angulo=360,Suave=100) {
  difference() {
    cylinder(d=D_I+6,h=D_Grosor+0.2,$fn=Suave,center=true);
      rotate_extrude(angle=Angulo,$fn=Suave)
        translate([D_I/2+D_Grosor/2, 0]) 
          translate([0, 0]) circle(d=D_Grosor+0.2,$fn=Suave);
  }
}


translate([0,0,Alto/2-35]) rotate([-Ang,0,0]) difference() {
  minkowski() {
    hull() {
      translate([Ancho/2-Curvado/2-Redondeo/2,Largo/2-Curvado/2-Redondeo/2,0]) cylinder(d=Curvado,h=Grosor_Carcasa-Redondeo,$fn=80,center=true);
      translate([-Ancho/2+Curvado/2+Redondeo/2,Largo/2-Curvado/2-Redondeo/2,0]) cylinder(d=Curvado,h=Grosor_Carcasa-Redondeo,$fn=80,center=true);
      translate([Ancho/2-Curvado/2-Redondeo/2,-Largo/2+Curvado/2+Redondeo/2,0]) cylinder(d=Curvado,h=Grosor_Carcasa-Redondeo,$fn=80,center=true);
      translate([-Ancho/2+Curvado/2+Redondeo/2,-Largo/2+Curvado/2+Redondeo/2,0]) cylinder(d=Curvado,h=Grosor_Carcasa-Redondeo,$fn=80,center=true);
    }
    sphere(d=Redondeo,$fn=40);
  }
// Taladros para los tornillos
      translate([Ancho/2-Curvado/2-Redondeo/2,Largo/2-Curvado/2-Redondeo/2-8,Grosor_Carcasa/2]) Tornillo_M3();
      translate([-Ancho/2+Curvado/2+Redondeo/2,Largo/2-Curvado/2-Redondeo/2-8,Grosor_Carcasa/2]) Tornillo_M3();
      translate([Ancho/2-Curvado/2-Redondeo/2,-Largo/2+Curvado/2+Redondeo/2+8,Grosor_Carcasa/2]) Tornillo_M3();
      translate([-Ancho/2+Curvado/2+Redondeo/2,-Largo/2+Curvado/2+Redondeo/2+8,Grosor_Carcasa/2]) Tornillo_M3();
// Taladro para el joystick
      translate([DX,DY,0]) Agujero(D_I=25,D_Grosor=Grosor_Carcasa,Angulo=360,Suave=200);
// Taladros para los Pulsadores
      translate([DXP1, DYP1,0]) Agujero(D_I=Diametro_P1,D_Grosor=Grosor_Carcasa,Angulo=360,Suave=200);
      translate([DXP2, DYP2,0]) Agujero(D_I=Diametro_P2,D_Grosor=Grosor_Carcasa,Angulo=360,Suave=200);
      translate([DXP3, DYP3,0]) Agujero(D_I=Diametro_P3,D_Grosor=Grosor_Carcasa,Angulo=360,Suave=200);
      translate([DXP4, DYP4,0]) Agujero(D_I=Diametro_P4,D_Grosor=Grosor_Carcasa,Angulo=360,Suave=200);
}
}


module Separador() {
difference() {
	cylinder(d=7,h=Distancia,$fn=120,center=true);
		cylinder(d=3.3,h=Distancia+2,$fn=120,center=true);
}
}





if (Mostrar=="Cajon") {
translate([0,0,Alto/2-KKK/2]) Superior();
Inferior();
}

if (Mostrar=="Alta") {
rotate([-Angulo,180,0]) Superior();
}

if (Mostrar=="Baja") {
Inferior();
}

if (Mostrar=="Contrapeso") {
Peso();
}

if (Mostrar=="Carcasa" && Protector=="SI") {
rotate([-Angulo,0,0])Carcasa();
}

if (Mostrar=="Separador") {
Separador();
}

if (Mostrar=="Tapa") {
rotate([180,0,0]) Tapa_Joystick();
}

if (Mostrar=="Tope") {
Tope_Muelle();
}

if (Mostrar=="Barra") {
rotate([0,90,0]) Palanca();
}

if (Mostrar=="Casq") {
Casquillo();
}

if (Mostrar=="Agarre") {
Pomo();
}

if (Mostrar=="Pres") {
Presilla();
}

if (Mostrar=="Patas") {
Pata();
}

if (Mostrar=="Tope_Arduino") {
rotate([90,0,0]) Cierre();
}
